function [Aeqin,beqin,jb,rowindex] = lprref(A,b,eqin,tol)
a0=find(eqin==0);
Aeqin=A(a0,:);
beqin=b(a0,:);
[m,n] = size(Aeqin);
rowindex=zeros(2,m);
rowindex(1,1:m)=a0';
if (nargin < 4)
    tol = max(m,n)*eps*norm(A,'inf'); 
end
i = 1;
j = 1;
jb = [];
while (i <= m) && (j <= n)
    [p,k] = max(abs(Aeqin(i:m,j))); 
    if (p < tol)
        Aeqin(i:m,j) = zeros(m-i+1,1);
        j = j + 1;
    elseif p~=0
        k = k+i-1;
        jb = [jb j];
        Aeqin([i k],:) = Aeqin([k i],:);
        beqin([i k],:)=beqin([k i],:);
        rowindex(:,[i k])=rowindex(:,[k i]);
        beqin(i,:)=beqin(i,:)/Aeqin(i,j);
        Aeqin(i,j:n) = Aeqin(i,j:n)/Aeqin(i,j);
        i_nz=find(Aeqin(:,j));
        i_nz=setdiff(i_nz,i);
        j_nz=find(Aeqin(i,:));
        for t = i_nz
            if beqin(i)~=0
                beqin(t)=beqin(t)-Aeqin(t,j)*beqin(i);
                toler=abs(beqin)<=tol;beqin(toler==1)=0;
            end
            Aeqin(t,j:n) = Aeqin(t,j:n) - Aeqin(t,j)*Aeqin(i,j:n);
            toler=abs(Aeqin)<=tol;Aeqin(toler==1)=0;
        end
        i = i + 1;
        j = j + 1;
    end
end
i=1;
for h=[1:i-1 i+1:m]
    if (Aeqin(h,:)==0)&(beqin(h)==0)
        rowindex(2,h)=1;
    end   
    if (Aeqin(h,:)==0)&(beqin(h)~=0)
        fprintf('\n Presolve: LP is INFEASIBLE \n');
        fprintf(1,'%c',7)
        return;
    end
end